//+------------------------------------------------------------------+
//|                               Original Indicator  ATR Levels.mq4 |
//|                                                 by Mike Ischenko |
//|                                     New levels ideas by Linuxser |
//|                                          Extra stuff by Linuxser |
//|                                            mishanya_fx@yahoo.com |
//|    Calculate the ATR for a month, then multiply by 0.50 0.75 and |
//|    take the last daily close.                                    |
//|    Add the obtained values to obtain a the new bands.            |
//|    S1 and R1 are very strong points, a move outside this values  |
//|    means a strongest trend.                                      |
//|    Using this levels for reversal is very good also.             |
//|                                                                  |
//|    PD: regards to FXCM who do not want to explain how was        |
//|    calculated the probability bands posted on dailyFX :P         |
//|                                                                  |
//|    Linuxser :)  day: 21 month: 02 year: 2007                     |
//+------------------------------------------------------------------+
#property copyright "o"
#property link      ""

#property indicator_chart_window



extern int ATRPeriod = 21;
extern color Slines = Red;
extern color Rlines = Green;
extern color Labels = Magenta;

double rates_d1[][6];
double H1, H2, H3, H4, H4t, H4tx, H5, L5, L4, L4t, L4tx, L3, L2, L1, halfatr, fullatr,dayclose;
int timeshift=0, timeshifts=0, beginner=0;
int periods;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
 
   
   ObjectDelete("H4atr line");
   ObjectDelete("L4atr line");
   ObjectDelete("L4atr label");
   ObjectDelete("H4atr label");
   
   ObjectDelete("H4tatr line");
   ObjectDelete("L4tatr line");
   ObjectDelete("L4tatr label");
   ObjectDelete("H4tatr label");
   
   ObjectDelete("H4tatrx line");
   ObjectDelete("L4tatrx line");    
   ObjectDelete("L4tatrx label");
   ObjectDelete("H4tatrx label");      
   
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   //if (counted_bars<1) return(0);
   
   
   switch (Period())
   {
      case PERIOD_M1:  {timeshifts=60; beginner=Hour()*60;} break;
      case PERIOD_M5:  {timeshifts=300; beginner=Hour()*12;} break;
      case PERIOD_M15: {timeshifts=900; beginner=Hour()*4;} break;
      case PERIOD_M30: {timeshifts=1800; beginner=Hour()*2;} break;
      case PERIOD_H1:  {timeshifts=3600; beginner=Hour()*1;} break;
      case PERIOD_H4:  {timeshifts=14400; beginner=Hour()*0.25;} break;
      case PERIOD_D1:  {timeshifts=86400; beginner=Hour()*0;} break;
    }   

   timeshift=timeshifts*12;
   
   if(Period() > 86400)
      {
         Print("Error - Chart period is greater than 1 day.");
         return(-1); // then exit
      }   


   
   ArrayCopyRates(rates_d1, Symbol(), PERIOD_D1);



   //beginner=Hour();
   
            fullatr = iATR(Symbol(), PERIOD_D1, ATRPeriod, 1);
            dayclose= iClose(Symbol(), PERIOD_D1, 1);
            
            L4 = dayclose - fullatr;   
            H4 = dayclose + fullatr;
            L4t = dayclose - fullatr*0.5;   
            H4t = dayclose + fullatr*0.5;
            L4tx = dayclose - fullatr*0.75;   
            H4tx = dayclose + fullatr*0.75;
            halfatr = fullatr * 0.5;   

         
   
   
   if (ObjectFind("H4atr Line") != 0) 
     {
      ObjectCreate("H4atr line",OBJ_HLINE,0,Time[0],H4);
      ObjectSet("H4atr line",OBJPROP_COLOR,Rlines);
      ObjectSet("H4atr line",OBJPROP_WIDTH,1);
     }
     else
     {
     ObjectMove("H4atr line", 0,Time[0],H4);
     }


   if (ObjectFind("L4atr Line") != 0) 
     {
      ObjectCreate("L4atr line",OBJ_HLINE,0,Time[0],L4);
      ObjectSet("L4atr line",OBJPROP_COLOR,Slines);
      ObjectSet("L4atr line",OBJPROP_WIDTH,1);
     }
     else
     {
     ObjectMove("L4atr line", 0,Time[0],L4);
     }

   if (ObjectFind("H4tatr Line") != 0) 
     {
      ObjectCreate("H4tatr line",OBJ_HLINE,0,Time[0],H4t);
      ObjectSet("H4tatr line",OBJPROP_COLOR,Rlines);
      ObjectSet("H4tatr line",OBJPROP_WIDTH,1);
     }
     else
     {
     ObjectMove("H4tatr line", 0,Time[0],H4t);
     }


   if (ObjectFind("L4tatr Line") != 0) 
     {
      ObjectCreate("L4tatr line",OBJ_HLINE,0,Time[0],L4t);
      ObjectSet("L4tatr line",OBJPROP_COLOR,Slines);
      ObjectSet("L4tatr line",OBJPROP_WIDTH,1);
     }
     else
     {
     ObjectMove("L4tatr line", 0,Time[0],L4t);
     }
 
   if (ObjectFind("H4tatrx Line") != 0) 
     {
      ObjectCreate("H4tatrx line",OBJ_HLINE,0,Time[0],H4tx);
      ObjectSet("H4tatrx line",OBJPROP_COLOR,Rlines);
      ObjectSet("H4tatrx line",OBJPROP_WIDTH,1);
     }
     else
     {
     ObjectMove("H4tatrx line", 0,Time[0],H4tx);
     }


   if (ObjectFind("L4tatrx Line") != 0) 
     {
      ObjectCreate("L4tatrx line",OBJ_HLINE,0,Time[0],L4tx);
      ObjectSet("L4tatrx line",OBJPROP_COLOR,Slines);
      ObjectSet("L4tatrx line",OBJPROP_WIDTH,1);
     }
     else
     {
     ObjectMove("L4tatrx line", 0,Time[0],L4tx);
     }




if(ObjectFind("H4atr label") != 0)
      {
      ObjectCreate("H4atr label", OBJ_TEXT, 0, Time[0]+timeshift, H4);
      ObjectSetText("H4atr label", "Probability Band R3: " + DoubleToStr(H4,4), 8, "Verdana", Labels);
      }
      else
      {
      ObjectMove("H4atr label", 0, Time[0]+timeshift, H4);
      } 

if(ObjectFind("L4atr label") != 0)
      {
      ObjectCreate("L4atr label", OBJ_TEXT, 0, Time[0]+timeshift, L4);
      ObjectSetText("L4atr label", "Probability Band S3: " + DoubleToStr(L4,4), 8, "Verdana", Labels);
      }
      else
      {
      ObjectMove("L4atr label", 0, Time[0]+timeshift, L4);
      } 

if(ObjectFind("H4tatr label") != 0)
      {
      ObjectCreate("H4tatr label", OBJ_TEXT, 0, Time[0]+timeshift, H4t);
      ObjectSetText("H4tatr label", "Probability Band R1: " + DoubleToStr(H4t,4), 8, "Verdana", Labels);
      }
      else
      {
      ObjectMove("H4tatr label", 0, Time[0]+timeshift, H4t);
      } 

if(ObjectFind("L4tatr label") != 0)
      {
      ObjectCreate("L4tatr label", OBJ_TEXT, 0, Time[0]+timeshift, L4t);
      ObjectSetText("L4tatr label", "Probability Band S1: " + DoubleToStr(L4t,4), 8, "Verdana", Labels);
      }
      else
      {
      ObjectMove("L4tatr label", 0, Time[0]+timeshift, L4t);
      } 
if(ObjectFind("H4tatrx label") != 0)
      {
      ObjectCreate("H4tatrx label", OBJ_TEXT, 0, Time[0]+timeshift, H4tx);
      ObjectSetText("H4tatrx label", "Probability Band R2: " + DoubleToStr(H4tx,4), 8, "Verdana", Labels);
      }
      else
      {
      ObjectMove("H4tatrx label", 0, Time[0]+timeshift, H4tx);
      } 

if(ObjectFind("L4tatrx label") != 0)
      {
      ObjectCreate("L4tatrx label", OBJ_TEXT, 0, Time[0]+timeshift, L4tx);
      ObjectSetText("L4tatrx label", "Probability Band S2: " + DoubleToStr(L4tx,4), 8, "Verdana", Labels);
      }
      else
      {
      ObjectMove("L4tatrx label", 0, Time[0]+timeshift, L4tx);
      } 
   return(0);
  }
//+------------------------------------------------------------------+